<?php
/*******************************************************************************
*
*		    [ admin/categories.php (franais) ]
*
*	--------------------------------------------------------------------------
*
*	Copyright : 	Groupe Dagonfield Gnsis
*	Site Web : 		http://www.dagonfield.com
*	E-mail : 		Nerevare - dagonfield@gmail.com
*					Met@lnono - nono1135@hotmail.com
*					yoursef - yoursef@gmail.com

*	--------------------------------------------------------------------------
*
*	Dernire modification le 05 Janvier 2007 par Met@lnono
*	Templates : 1
*		admin/categories.tpl
*
*******************************************************************************/

define( 'IN_PORTFOLIO', TRUE );
$location = '../';
include( $location . 'start.php' );

// On inclu le header
include( $location . 'admin/header.php' );

// Rcupration des donnes
if( isset( $_GET['cat'] ) || isset( $_POST['cat'] ) )
{
	$cat = ( isset( $_GET['cat'] ) ) ? htmlSpecialChars( $_GET['cat'] ) : htmlSpecialChars( $_POST['cat'] );
}
else
{
	$cat = '';
}

if( isset( $_GET['mode'] ) || isset( $_POST['mode'] ) )
{
	$mode = ( isset( $_GET['mode'] ) ) ? htmlSpecialChars( $_GET['mode'] ) : htmlSpecialChars( $_POST['mode'] );
}
else
{
	$mode = '';
}

if( !is_numeric( $cat ) && $cat != '' )
{
	redirection( 'categories.php' );
}

// Chargement des donnes sur les categories et les pages
$Cache->load_table( 'categories' );
$Cache->load_table( 'pages' );

// On dfini le template
$Tpl->set_filenames( array( 'categories' => 'admin/categories.tpl' ) );

// Si le formulaire est soumis on enregistre les donnes
if( isset( $_POST['soumettre'] ) )
{
	$Tpl->create_block( 'enregistrement' );
	$erreur = '';

	if( empty( $_POST['nom'] ) )
	{
		$erreur = $langue['erreur_nom_vide'];
	}

	if( $mode == 'modifier' && empty( $erreur ) )
	{
		$categories[$cat]['nom'] = htmlSpecialChars( trim( $_POST['nom'] ) );
		$categories[$cat]['activation'] = ( isset( $_POST['activation'] ) && $_POST['activation'] == 1 ) ? 1 : 0;

		$Cache->write_in_cache( $categories, 'categories', count( $categories ) );
	}
	elseif( $mode == '' && empty( $erreur ) )
	{
		$categories[] = array(
			'nom' 		=> htmlSpecialChars( $_POST['nom'] ),
			'activation' 	=> ( isset( $_POST['activation'] ) && $_POST['activation'] == 1 ) ? 1 : 0,
		);
		$Cache->write_in_cache( $categories, 'categories', count( $categories ) );
	}

	$Tpl->assign_vars( array(
		'L_ENREGISTREMENT'	=> empty( $erreur ) ? '<img src="' . $location . 'img/sys/ok.png" width="16" height="16" border="0" style="vertical-align: -25%;" alt="" />&nbsp;' . $langue['enregistrement_reussi'] : '<img src="' . $location . 'img/sys/error.png" width="16" height="16" border="0" style="vertical-align: -25%;" alt="" />&nbsp' . $erreur . '<br />',
	) );
}

// Si on dplace une page vers le haut ou vers le bas
if ( $mode == 'monter' || $mode == 'descendre' )
{
	if ( ( $mode == 'monter' && $cat > 0 ) || ( $mode == 'descendre' && $cat < $compte_categories - 1 ) )
	{
		// Modification de l'id de la catgorie
		$tmp_cat = ( $mode == 'monter' ) ? $cat - 1 : $cat + 1;
		$a = $categories[$cat];
		$b = $categories[$tmp_cat];
		$categories[$cat] = $b;
		$categories[$tmp_cat] = $a;
		$Cache->write_in_cache( $categories, 'categories', count( $categories ) );

		// Modification des id de catgories dans les pages
		for( $i = 0; $i < $compte_pages; $i++ )
		{
			if( intval( $pages[$i]['categorie'] ) == intval( $cat ) )
			{
				$pages[$i]['categorie'] = intval( $tmp_cat );
			}
			elseif( intval( $pages[$i]['categorie'] ) == intval( $tmp_cat ) )
			{
				$pages[$i]['categorie'] = intval( $cat );
			}
		}
		$Cache->write_in_cache( $pages, 'pages', $compte_pages );
	}
	else
	{
		redirection( 'categories.php' );
	}
}
// Si on supprime une catgories
elseif( $mode == 'supprimer' && $cat != '' )
{
	if( isset( $_POST['confirm_oui'] ) )
	{
		// Suppression de la catgorie
		array_splice( $categories, $cat, 1 );
		$Cache->write_in_cache( $categories, 'categories', count( $categories ) );

		// Modification des id de catgories dans les pages
		for( $i = 0; $i < $compte_pages; $i++ )
		{
			if( intval( $pages[$i]['categorie'] ) > intval( $cat ) )
			{
				$pages[$i]['categorie'] = intval( $pages[$i]['categorie'] ) - 1;
			}
		}
		$Cache->write_in_cache( $pages, 'pages', $compte_pages );
		
		redirection( 'categories.php' );
	}
	elseif( isset( $_POST['confirm_non'] ) )
	{
		redirection( 'categories.php' );
	}
	else
	{
		confirmation( 'categories.php', $langue['confirm_suppr_categories'], array( 'mode' => $mode, 'cat' => $cat ) );
	}
}

// Rcupration des donnes sur les catgories
foreach( $categories as $id_cat => $values_cat )
{
	$Tpl->assign_block_vars( 'cat', array(
		'CATEGORIE_NOM'			=> $values_cat['activation'] == 1 ? '<span style="color: rgb(0, 170, 0);"><b>' . $values_cat['nom'] . '</b></span>' : '<span style="color: rgb(255, 0, 0);">' . $values_cat['nom'] . '</span>',

		'U_CATEGORIE_EDIT'		=> '<a href="' . ajout_sid( $location . 'admin/categories.php?mode=modifier&amp;cat=' . $id_cat, TRUE ) . '" title="' . $langue['categories_modifier'] . '"><img src="' . $location . 'img/sys/folder_edit.png" width="16" height="16" border="0" align="top" alt="" /></a>',
		'U_CATEGORIE_DEL'		=> '<a href="' . ajout_sid( $location . 'admin/categories.php?mode=supprimer&amp;cat=' . $id_cat, TRUE ) . '" title="' . $langue['categories_supprimer'] . '"><img src="' . $location . 'img/sys/folder_delete.png" width="16" height="16" border="0" align="top" alt="" /></a>',

		'U_CATEGORIE_MONTER' 	=> ( $id_cat != 0 ) ? '<a href="' . ajout_sid( 'categories.php?mode=monter&amp;cat=' . $id_cat, TRUE ) . '" title=""><img src="' . $location . 'img/sys/arrow_up.png" width="16" height="16" border="0" style="vertical-align: -25%;" alt="" />' . $langue['pages_monter'] . '</a>' : '&nbsp;',
		'U_CATEGORIE_DESCENDRE' => ( $id_cat != count( $categories ) - 1 ) ? '<a href="' . ajout_sid( 'categories.php?mode=descendre&amp;cat=' . $id_cat, TRUE ) . '" title=""><img src="' . $location . 'img/sys/arrow_down.png" width="16" height="16" border="0" style="vertical-align: -25%;" alt="" />' . $langue['pages_descendre'] . '</a>' : '&nbsp;',
	) );
}

$Tpl->assign_vars( array(
	'RACINE'					=> $location,
	'CATEGORIE_NOM'				=> $mode == 'modifier' && isset( $categories[$cat] ) ? $categories[$cat]['nom'] : '',
	'CATEGORIE_ACTIVATION'		=> $mode == 'modifier' && isset( $categories[$cat] ) && $categories[$cat]['activation'] == 1 ? 'value="1" checked=checked' : 'value="1"',

	'L_CATEGORIES_TITRE'		=> $langue['categories_titre'],
	'L_CATEGORIES_LISTE'		=> $langue['categories_liste'],
	'L_CATEGORIES_LISTE_EXP'	=> $langue['categories_liste_exp'],
	'L_CATEGORIES_CREATION'		=> $mode == 'modifier' && $cat != '' ? '<img src="' . $location . 'img/sys/folder_edit.png" width="16" height="16" border="0" align="bottom" alt="" /> ' . $langue['categories_edition'] . ' : | <a href="categories.php" title=""><img src="' . $location . 'img/sys/folder_add.png" width="16" height="16" border="0" align="bottom" alt="" />&nbsp;' . $langue['categories_creation'] . '</a>' : '<img src="' . $location . 'img/sys/folder_add.png" width="16" height="16" border="0" align="bottom" alt="" />&nbsp;' . $langue['categories_creation'] . ' :',
	'L_CATEGORIES_CREATION_EXP'	=> $mode == 'modifier' && $cat != '' ? $langue['categories_edition_exp'] : $langue['categories_creation_exp'],
	'L_CATEGORIES_NOM'			=> $langue['categories_nom'],
	'L_CATEGORIES_ACTIVATION'	=> $langue['categories_activation'],
	'L_SOUMETTRE'				=> $langue['soumettre'],

	'U_ACTION' 					=> $mode == 'modifier' && $cat != '' ? ajout_sid ( $location . 'admin/categories.php?mode=modifier&amp;cat=' . $cat, TRUE ) : ajout_sid ( $location . 'admin/categories.php', TRUE ),
) );

$Tpl->pparse( 'categories' );

// On inclu le footer
include( $location . 'admin/footer.php' );
?>