<?php
/*******************************************************************************
*
*		    [ ./includes/class/class_cache.php (franais) ]
*
*	--------------------------------------------------------------------------
*	Commenc le : 	20 septembre 2004
*	Copyright : 	Groupe Fire Soft Board
*	Site Web : 		http://www.fire-soft-board.com
*	E-mail : 		support@fire-soft-board.com
*	--------------------------------------------------------------------------
*	Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les 
*	termes de la Licence Publique Gnrale GNU publie par la Free Software Foundation 
*	(version 2). Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails. 
*	Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps 
*	que ce programme ; si ce n'est pas le cas, crivez  la Free Software Foundation, 
*	Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis. 
*	--------------------------------------------------------------------------
*
*	Dernire modification le 2 novembre 2005 par Genova
*	Templates : 0
*
*******************************************************************************/

/*
** Classe permettant l'criture de tableux PHP dans un fichier.
** La reprsentation est similaire  celle d'une table de base de donne,
** a savoir une numrotation des lignes en indice et pour chacun des lignes un champ
** associ  la donne qu'il contient.
** Les tableaux sont chargs dynamiquement, pour rajouter donc un lment  un tableau il
** faut regnrer le fichier de cache avec les champs en plus.
*/

define('CACHE_FTP', 1);
define('CACHE_SQL', 2);

class cache
{
	var $dir;
	var $code_to_write = '';
	var $only_sql = array();

	/*
	** Constructeur, assigne un rpertoire
	*/
	function cache($dir)
	{
		$this->dir = $dir;
	}

	/*
	** Mthode inspire de la classe de FSB2
	** Permet de charger un fichier cache, soit depuis le FTP, soit depuis la table cache de la base de donne
	** -----
	** $table ::	Nom de la table  charger
	*/
	function load_table($table, $load_type = CACHE_FTP)
	{
		$fields = 'fields_' . $table;
		$count = 'compte_' . $table;
		global $bdd, $langue, $$count, $$fields, $$table;

		if (file_exists($this->dir . 'fichier_' . $table . '.php'))
		{
			include($this->dir . 'fichier_' . $table . '.php');
		}
		else
		{
			die('Le fichier ' . $this->dir . 'fichier_' . $table . '.php n\'existe pas');
		}
	}

	/*
	** Ecrit le tableau pass en argument dans le cache en utilisant sa fonction spcifique
	** -----
	** $data :: Tableau  crire
	** $function :: Nom de la table
	** $count_data :: Argument obsolte
	*/
	function write_in_cache($data, $table, $count_data = 0)
	{
		$fields = 'fields_' . $table;
		global $bdd, $langue, $$fields, $$table;

		if (!$this->is_aborting())
		{
			$this->code_to_write = "<?php\n" . $this->obtain_cache_code($data, $table) . "\n?>";
			$this->write_data($this->code_to_write, $this->dir . 'fichier_' . $table . '.php');
		}
		else
		{
			die('La connexion a t intrompue, aucune donne n\'a t crite dans les fichiers');
		}
	}

	/*
	** gnre le code  crire dans le fichier cache
	** -----
	** $data :: Tableau  crire
	** $function :: Nom de la table
	*/
	function obtain_cache_code($tab, $function)
	{
		$fields = 'fields_' . $function;
		global $$fields;

		if (count($$fields))
		{
			$code = get_array_code($$fields, 'fields_' . $function) . "\n";
		}
		else
		{
			$tmp = array();
			if (is_array($tab[0]))
			{
				foreach($tab[0] AS $k => $v)
				{
					$tmp[] = $k;
				}
			}
			$code = get_array_code($tmp, 'fields_' . $function) . "\n";
		}
  
		$code .= get_array_code($tab, $function) . "\n";
		$code .= '$compte_' . $function . ' = count($' . $function . ');';
		return ($code);
	}

	/*
	** Vrifie si la connexion n'a pas t intrompue (afin de ne pas corrompre un fichier)
	*/
	function is_aborting()
	{
		@ignore_user_abort(1);
		return (@connection_aborted() ? TRUE : FALSE);
	}

	/*
	** Ecrit des donnes dans un fichier
	** -----
	** $code :: Le texte  crire
	** $file :: Le fichier dans lequel crire le texte
	*/
	function write_data($code, $file)
	{
		@umask(0);
		@chmod($file, 0666);
		$handle = @fopen($file, 'w');
		@flock($handle, LOCK_EX);
		if (@fwrite($handle, $code))
		{
			@fflush($handle);
			@flock($handle, LOCK_UN);
			@fclose($handle);
			@chmod($file, 0666);
			unset($code);
			return (TRUE);
		}
		else
		{
			die('Impossible d\'crire dans le fichier ' . $file);
		}
	}

	/*
	** Convertit un tableau de cache en tableau associatif.
	** Le tableau de base ne doit comporter que deux champs par
	** ligne, avec comme clef 'name' et 'value'.
	** -----
	** $tab :: Tableau  convertir
	*/
	function convert_to_simple_array($tab, $name = 'name', $value = 'value')
	{
		$new_tab = array();
		foreach ($tab AS $v)
		{
			$new_tab[$v[$name]] = $v[$value];
		}
		return ($new_tab);
	}

	/*
	** Convertit le tableau associatif en tableau de cache.
	** Le tableau doit tre de la forme
	** $tab = array('k' => 'v', 'k' => 'v', 'k' => 'v', etc ...);
	** -----
	** $tab :: Tableau  convertir
	*/
	function convert_to_normal_array($tab, $name = 'name', $value = 'value')
	{
		$new_tab = array();
		$k = 0;
		foreach ($tab AS $key => $v)
		{
			$new_tab[$k][$name] = $key;
			$new_tab[$k][$value] = $v;
			$k++;
		}
		return ($new_tab);
	}
}
?>
