<?php

function affiche_page( $id_page, $id_feuille = 0 )
{
	global $pages;

	if( $pages[$id_page]['type'] == 'frame' )
	{
		// onLoad="autoResize(this);"
		return '<center><iframe src="' . $pages[$id_page]['page'][0] . '" id="iframe" frameborder="0" height="' . $pages[$id_page]['height'] . '" width="' . $pages[$id_page]['width'] . '" scrolling="auto"></iframe></center>';
	}
	elseif( $pages[$id_page]['type'] == 'php' )
	{
		include( $pages[$id_page]['page'][0] );
	}
	else
	{
		return stripslashes( $pages[$id_page]['page'][$id_feuille] );
	}
}


function affiche_pagination( $page, $feuille, $rapide = FALSE, $sid = '' )
{
	global $pages, $config;

	$affichage_pages = count( $pages[$page]['page'] ) > 1 ? 'Pages : ' : '';
	for( $i = 0; $i < count( $pages[$page]['page'] ) && count( $pages[$page]['page'] ) > 1; $i++ )
	{
		$href = ( $rapide == TRUE ) ? '#" onclick="xajax_start_edit_form( ' . $page . ', ' . $i . ', \'' . $sid . '\' ); return false;' : ajout_sid( 'index.php?page=' . $page . '&amp;feuille=' . $i . ( ( isset( $pages[$page]['keyword'] ) && $config['url_rewriting'] && $pages[$page]['keyword'] != '' ) ? '&amp;keyword=' . clean_keyword( $pages[$page]['keyword'] ) : '' ), TRUE );
		$affichage_pages .= $feuille != $i ? '<a href="' . $href . '" title="">' . ( $i + 1 ) . '</a>&nbsp;' : '[<b>' . ( $i + 1 ) . '</b>]&nbsp;' ;
	}
	return '<br /><br />' . $affichage_pages;
}

/*--------------------------------------------------------------------------
Fonction de redirection

	$url 		=> URL de redirection
	$lien 		=> l'URL va-t-il servir pour un lien hypertexte ou pour un passage de donnes en POST ?
--------------------------------------------------------------------------*/
function redirection( $url, $lien = FALSE )
{
	header( 'Location: ' . ajout_sid( $url, $lien ) );
	exit();
}

/*--------------------------------------------------------------------------
Liste les langues disponibles pour M_P (dans un <select>)

	$racine 		=> dossier racine
	$name_select 	=> nom du select
	$default_select => entre selectionn par default
--------------------------------------------------------------------------*/
function lister_nationalites( $racine, $name_select, $default_select )
{
	if( $dossier = opendir( $racine ) )
	{
		$dossiers = '<select name="' . $name_select . '" style="width:40px;padding:0px;padding-left:0px;text-decoration:none;background-position:left center;background-repeat:no-repeat;">';
		while( FALSE !== ( $fichier = readdir( $dossier ) ) )
		{
			if( $fichier != '.' && $fichier != '..' && $fichier != 'index.html' )
			{
				if( is_dir( $racine . $fichier ) )
				{
					$selection = ( $fichier == $default_select ) ? 'selected="selected"' : '';
					$dossiers .= '<option style="width:40px;padding:0px;padding-left:20px;text-decoration:none;background-image:url(\'../img/drap/' . $fichier . '.png\');background-position:left center;background-repeat:no-repeat;" value="' . $fichier . '" ' . $selection . '>' . $fichier . '</option>';
				}
			}
		}
		$dossiers .= '</select>';
		closedir( $dossier );
	}

	return $dossiers;
}

/*--------------------------------------------------------------------------
Liste les rpertoires prsents dans un autre rpertoire (dans un <select>)

	$racine 		=> dossier racine
	$name_select 	=> nom du select
	$default_select => entre selectionn par default
--------------------------------------------------------------------------*/
function lister( $racine, $name_select, $default_select )
{
	if( $dossier = opendir( $racine ) )
	{
		$dossiers = '<select name="' . $name_select . '">';
		while( FALSE !== ( $fichier = readdir( $dossier ) ) )
		{
			if( $fichier != '.' && $fichier != '..' && $fichier != 'index.html' )
			{
				if( is_dir( $racine . $fichier ) )
				{
					$selection = ( $fichier == $default_select ) ? 'selected="selected"' : '';
					$dossiers .= '<option value="' . $fichier . '" ' . $selection . '>' . $fichier . '</option>';
				}
			}
		}
		$dossiers .= '</select>';
		closedir( $dossier );
	}

	return $dossiers;
}

/*--------------------------------------------------------------------------
Renvoie la structure du tableau pass en paramtre sous
forme de chane de caractre (qui peut ainsi tre crite
dans un fichier cache par exemple). L'indentation et la mise
en forme du code via des espaces et des \n est prise en
compte.

	$array 		=> Tableau dont la structure sera rcupre
	$array_name => Nom du tableau
--------------------------------------------------------------------------*/
function get_array_code( $array, $array_name )
{
	if ( !function_exists( 'get_array_code_rec' ) )
	{
		function get_array_code_rec($array, $end, $indent = '')
		{
			$str = "array(\n";
			while (list($k, $v) = each($array))
			{
				if (is_array($v))
				{
					$str .= "$indent   '$k' => " . get_array_code_rec($v, FALSE, $indent . '   ');
				}
				else
				{
					$str .= "$indent   '$k' => '" . simpleslashes($v) . "',\n";
				}
			}
			$str .= "$indent)" . (($end) ? ';' : ',') . "\n";
			return ($str);
		}
	}

	$str = '$' . $array_name . ' = ' . get_array_code_rec($array, TRUE);

	return ($str);
}

/*--------------------------------------------------------------------------
Fonction permettant de rajouter des antislashes aux \ et ' uniquement

	$text => texte  modifier
--------------------------------------------------------------------------*/
function simpleslashes( $text )
{
	$text = str_replace( '\\', '\\\\', $text );
	$text = str_replace( "'", "\'", $text );

	return ( $text );
}

/*--------------------------------------------------------------------------
Fonction permettant d'afficher une fentre de confirmation

	$fichier 	=> Fichier cible de la confirmation
	$message 	=> Message de confirmation
	$params 	=> Tableau contenant les paramtres  passer via l'action et des champs cachs
--------------------------------------------------------------------------*/
function confirmation( $fichier, $message, $params )
{
	global $config, $langue, $location, $Tpl;

	$v_action = $fichier;
	$hidden = '';
	$i = 0;
	while ( list($cle, $valeur) = each($params) )
	{
		if ( is_array($valeur) )
		{
			foreach ( $valeur AS $valeur_bis )
			{
				$hidden .= '<input type="hidden" name="' . $cle . '" value="' . $valeur_bis . '" />';
			}
		}
		else
		{
			$v_action .= ( $i == 0 ) ? '?' : '&amp;';
			$v_action .= $cle . '=' . $valeur;
			$hidden .= '<input type="hidden" name="' . $cle . '" value="' . $valeur . '" />';
		}
		$i++;
	}

	$Tpl->set_filenames(array('confirmation' => 'confirmation.tpl'));

	$Tpl->assign_vars( array(
		'L_TITRE' 	=> $langue['con_titre'],
		'L_MESSAGE' => $message,
		'L_OUI' 	=> $langue['oui'],
		'L_NON' 	=> $langue['non'],

		'V_ACTION' 	=> ajout_sid($v_action),

		'HIDDEN' 	=> $hidden
	));

	$Tpl->pparse( 'confirmation' );

	include( $location . 'admin/footer.php' );

	exit;
}

/*--------------------------------------------------------------------------
Fonction permettant d'afficher une fentre d'informations

	$titre 		=> titre de la fentre
	$message 	=> Message de l'information
--------------------------------------------------------------------------*/
function info( $titre, $message )
{
	global $config, $langue, $location, $Tpl;

	$Tpl->set_filenames( array( 'information' => 'information.tpl' ) );

	$Tpl->assign_vars( array(
		'L_TITRE' 	=> $titre,
		'L_MESSAGE' => $message,
	));

	$Tpl->pparse( 'information' );

	include( $location . 'admin/footer.php' );

	exit;
}

/*--------------------------------------------------------------------------
Fonction permettant de lister les pages disponible dans M_P (dans un <select>)

	$nom_select => nom du select
	$lien		=> permet d'exclure ou non les pages de type lien de la liste
--------------------------------------------------------------------------*/
function liste_pages( $nom_select, $lien = FALSE )
{
	global $config, $pages;

	$liste_pages = '<select name="' . $nom_select . '">';
	foreach ( $pages as $id => $valeur )
	{
		$selection = ( $id == $config[$nom_select] ) ? 'selected="selected"' : '';
		$liste_pages .= ( $pages[$id]['type'] == 'lien' && $lien == TRUE ) || $pages[$id]['activation'] != 'oui' ? '' : '<option value="' . $id . '" ' . $selection . '>' . $pages[$id]['titre'] . '</option>';		
	}
	
	$liste_pages .= '</select>';

	return $liste_pages;
}

/*--------------------------------------------------------------------------
Fonction permettant de lister les categories disponible dans M_P (dans un <select>)

	$nom_select => nom du select
	$id_page	=> $id de la page associe dans le formulaire
--------------------------------------------------------------------------*/
function liste_categories( $nom_select, $id_page = NULL )
{
	global $pages, $categories;

	$disabled = ( isset( $pages[$id_page]['emplacement'] ) && $pages[$id_page]['emplacement'] == 'haut' ) ? 'disabled="disabled"' : '';
	$liste_categories = '<select name="' . $nom_select . '" id="' . $nom_select . '"' . $disabled . '>';
	foreach( $categories as $id => $valeur )
	{
		$selection = ( isset( $pages[$id_page]['categorie'] ) && $pages[$id_page]['categorie'] == $id ) ? 'selected="selected"' : '';
		$liste_categories .= ( $categories[$id]['activation'] == 1 ) ? '<option value="' . $id . '" ' . $selection . '>' . $categories[$id]['nom'] . '</option>' : '';
	}
	$liste_categories .= '</select>';

	return $liste_categories;
}

/*--------------------------------------------------------------------------
Fonction permettant de synchroniser les smileys entre FCKeditor et M_P

	$racine => racine du script
--------------------------------------------------------------------------*/
function synchro_smileys( $racine )
{
	// Ouverture du fichier config de FCKeditor
	$fichier = $racine . 'includes/js/fckconfig.js';
	$fichier_array = file( $fichier );

	// Cration de la variable 'FCKConfig.SmileyImages'
	$fichier_config = 'FCKConfig.SmileyImages = [';
	$tour = 0;
	$smileys_rep = opendir( $racine . 'fckeditor/editor/images/smiley' );
	while( ( $smileys_fichier = readdir( $smileys_rep ) ) !== FALSE )
	{
		if ( $smileys_fichier != '.' && $smileys_fichier != '..' && $smileys_fichier != 'Thumbs.db' )
		{
			if( $tour != 0 )
			{
				$fichier_config .= ',';
			}
			$tour++;
			$fichier_config .= '\'' . $smileys_fichier . '\'' ;
		}
	}
	closedir( $smileys_rep );
	$fichier_config .= '] ;';

	// Modification de la variable dans le tableau
	$fichier_array[187] = $fichier_config . "\n";

	// Enregistrement dans le fichier
	$fd = @fopen( $racine . 'includes/js/fckconfig.js', 'w' );
	for( $i = 0; $i < count( $fichier_array ); $i++ )
	{
		fwrite( $fd, $fichier_array[$i] );
	}
	fclose( $fd );
}

/*--------------------------------------------------------------------------
Fonction permettant de lister les fichiers prsent dans un rpertoire

	$dossier => emplacement du rpertoire
--------------------------------------------------------------------------*/
function liste_fichiers( $dossier )
{
	// Dclaration du tableau
	$fichiers = array();

	// Ouverture du rpertoire
	if( $dossier = opendir( $dossier ) )
	{
		while( FALSE !== ( $fichier = readdir( $dossier ) ) )
		{
			if( $fichier != '.' && $fichier != '..' && $fichier != 'index.html' )
			{
				$fichiers[] = $fichier;
			}
		}
		// Fermeture du rpertoire
		closedir( $dossier );
	}

	return $fichiers;
}

/*--------------------------------------------------------------------------
Fonction de nettoyage des phrases cls des caractres spciaux

	$keyword => phrase cl  traiter
--------------------------------------------------------------------------*/
function clean_keyword( $keyword )
{
	$keyword 		= html_entity_decode( $keyword );
    $char_search  	= '';
    $char_replace	= 'cnaaaaaaaeeeeeeeeeiiiiiiiioooooooouuuuuuuuu';
    $keyword    	= strtr( trim( strtolower( $keyword ) ), $char_search, $char_replace );
    $keyword     	= preg_replace( '/[^a-z0-9-]/', '-', $keyword );
	$keyword   		= trim( $keyword, '-' );
	$keyword		= urlencode( $keyword );

    return $keyword;
}

/*--------------------------------------------------------------------------
Fonction permettant de rcrire les URL en .html

	$buffer => buffer de sortie  modifier
--------------------------------------------------------------------------*/
function replace_mod_rewrite( $buffer )
{
	// URLs d'entre
	$url_in = array(
		/*'#index\.php\?page=([0-9]+)&(amp;)?feuille=([0-9]+)&(amp;)?keyword=([a-z-]+)#i',
		'#index\.php\?page=([0-9]+)&(amp;)?feuille=([0-9]+)#i',
		'#index\.php\?page=([0-9]+)&(amp;)?keyword=([a-z-]+)#i',
		'#index\.php\?page=([0-9]+)#i',
		'#([a-z]+).php\?page=([0-9]+)#i',
		// '#index\.php#i', 
		*/
		'#forum_forum\.php\?id=([0-9\_]+)#i',
		'#index\.php#i',
		'#forum\.php#i',
		'#liste_membre\.php#i',
		'#calendar\.php#i',
		'#video\.php#i',
		'#forum_sujet\.php\?id=([0-9\_]+)#i',
		'#calendar_annonce\.php\?id=([0-9\_]+)#i',
		'#index\.php\?page=([0-9\_]+)#i',
		'#download\.php\?mode=([a-z\_]+)&(amp;)?id=([0-9]+)#i',
		'#download_files\.php\?id=([0-9\_]+)#i',
		'#profil_membre\.php\?id=([0-9\_]+)&&mode=([a-zA-Z0-9]+)&&mpto=([a-zA-Z0-9]+)#i',
		
		
		'#sujet_news\.php\?id=([0-9\_]+)#i',
		'#profil_membre\.php\?id=([0-9\_]+)#i',
		'#mp\.php\?id=([0-9\_]+)#i',
		'#raid\.php\?mode=([0-9\_]+)#i',
		'#roster\.php#i',
		'#apply\.php#i',
		'#download\.php#i',
		'#tchatbox\.php#i',
	);

	// URLs de sortie
   $url_out = array(
   		'topic-\\1.html',
   		'index.html',
   		'forum.html',
		'liste_membre.html',
		'calendrier.html',
		'video.html',
   		'sujet-\\1.html',
		'calendrier-f\\1.html',
		'index-p\\1.html',
		'download-\\1\\3.html',
		'fichier-\\1.html',
		'sendmp-\\1.mode-\\2.to-\\3.html',
		
		'news-\\1.html',
		'profil-\\1.html',
		'mp-\\1.html',
		'raid-\\1.html',
		'roster.html',
		'apply.html',
		'download.html',
		'tchat.html',
   		/*
		'index-\\1-\\3.\\5.html',
		'index-\\1-\\3.html',
		'index-\\1.\\3.html',
		'index-\\1.html',
		'\\1-\\2.html',
		// 'index.html',
		*/
	);

	// Traitement des URLs
	$buffer = preg_replace( $url_in, $url_out, $buffer );

	// Renvoi du buffer
	return $buffer;
}

/*--------------------------------------------------------------------------
Fonction permettant d'crire dans le fichier .htaccess (Gestion des erreurs et de l'URL Rewriting)

	$racine => racine du script
--------------------------------------------------------------------------*/
function synchro_htaccess( $racine, $domaine, $erreur404, $url )
{
	// Rcupration des sous-rpertoires de stockage
	$subfolder = str_replace( $_SERVER['HTTP_HOST'], '', $domaine );

	// Cration de la ligne concernant l'erreur 404
	$fichier_config = 'ErrorDocument 404 http://' . $domaine . '/index.php?page=' . $erreur404 . "\n";

	// Cration des pour l'URL Rewriting
	if( $url == 1 )
	{
		
		$fichier_config .= 'RewriteEngine on' . "\n";
		$fichier_config .= 'RewriteRule ^topic-([0-9]+)\.html$  forum_forum.php?id=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^sujet-([0-9]+)\.html$  forum_sujet.php?id=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^profil-([0-9]+)\.html$  profil_membre.php?id=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^news-([0-9]+)\.html$  sujet_news.php?id=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^mp-([0-9]+)\.html$  mp.php?id=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^raid-([0-9]+)\.html$  raid.php?mode=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^calendrier-f([0-9]+)\.html$  calendar_annonce.php?id=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^index-p([0-9]+)\.html$  index.php?page=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^download-afficher([0-9]+)\.html$  download.php?mode=afficher&id=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^fichier-([0-9]+)\.html$  download_files.php?id=$1  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^sendmp-([0-9]+)\.mode-([a-zA-Z0-9]+)\.to-([a-zA-Z0-9]+)\.html  profil_membre\.php\?id=$1&&mode=$2&&mpto=$3' . "\n";
		
		$fichier_config .= 'RewriteRule ^index\.html$  index.php  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^forum\.html$  forum.php  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^liste_membre\.html$  liste_membre.php  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^calendrier\.html$  calendar.php  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^tchat\.html$  tchatbox.php  [L] ' . "\n";
		$fichier_config .= 'RewriteRule ^video\.html$  video.php  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^roster\.html$  roster.php  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^apply\.html$  apply.php  [L]' . "\n";
		$fichier_config .= 'RewriteRule ^download\.html$  download.php  [L]' . "\n";
		/*
		
		
		$fichier_config .= 'RewriteRule ^index-([0-9]*)-([0-9]*).([a-z-]*).html ' . $subfolder . '/index.php?page=$1&feuille=$2&keyword=$3' . "\n";
		$fichier_config .= 'RewriteRule ^index-([0-9]*)-([0-9]*).html ' . $subfolder . '/index.php?page=$1&feuille=$2' . "\n";
		$fichier_config .= 'RewriteRule ^index-([0-9]*).([a-z-]*).html ' . $subfolder . '/index.php?page=$1&keyword=$2' . "\n";
		$fichier_config .= 'RewriteRule ^index-([0-9]*).html ' . $subfolder . '/index.php?page=$1' . "\n";
		$fichier_config .= 'RewriteRule ^([a-z]*)-([0-9]*).html ' . $subfolder . '/$1.php?page=$2' . "\n";
		$fichier_config .= 'RewriteRule ^index.html$ ' . $subfolder . '/index.php' . "\n";
		*/
	}

	// Enregistrement dans le fichier
	$fd = @fopen( $racine . '.htaccess', 'w' );
	fwrite( $fd, $fichier_config );
	fclose( $fd );
}

/*--------------------------------------------------------------------------
Fonction permettant d'crire dans le fichier .htaccess (Gestion des erreurs et de l'URL Rewriting)

	$racine => racine du script
--------------------------------------------------------------------------*/
function string_gen()
{
	// definition de la taille de la chaine (il sera compris entre 5 et 10 caractres)
	$taille = rand( 5, 10 );

	//tableau des consonnes
	$c1 = array( 'b', 'c', 'd', 'f', 'g', 'h', 'j', 'k', 'l', 'm', 'n', 'p', 'q', 'r', 's', 't', 'v', 'w', 'x', 'z', 'dd', 'ff', 'll', 'mm', 'nn', 'pp', 'rr', 'ss', 'tt' );

	//tableau des voyelles. certaines voyelles ont t doubles ou tripl, comme le a ou le e, car elles sont tres repandu, contrairement au y
	$c2 = array( 'a', 'a', 'a', 'e', 'e', 'e', 'i', 'i', 'o', 'o', 'u', 'u', 'y' );

	// Initialisation et gnration du code
	$code = '';
	for( $i = 1; $i < $taille; $i++ )
	{
		$code .= ( $i%2 == 0 ) ? $c1[rand( 0, count( $c1 ) -1 )] : $c2[rand( 0, count( $c2 ) -1 )];
	}

	// Ajout d'un nombre supplmentaire compris entre 0 et 999
	$code .= '_' . rand( 0, 999 );

	// Renvoi du code
	return $code;
}

/*--------------------------------------------------------------------------
Fonction de vrification de la syntaxe des adresses email

	$email => adresse email  tester
--------------------------------------------------------------------------*/
function email_verif( $email )
{
	$syntaxe = '#^[\w.-]+@[\w.-]+\.[a-zA-Z]{2,5}$#';
	if( preg_match( $syntaxe, $email ) )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

/*--------------------------------------------------------------------------
Fonction permettant de vider un rpertoire de ses fichiers

	$email => emplacement du rpertoire  vider
--------------------------------------------------------------------------*/
function empty_dir( $path )
{
	if( $dir_handle = opendir( $path ) )
	{
		while( $file = readdir( $dir_handle ) )
		{
			if( $file == "." || $file == ".." )
			{
				if( !@unlink( $path . '/' . $file ) )
				{
					continue;
				}
			}
			else
			{
				@unlink( $path . '/' . $file );
			}
		}
		closedir( $dir_handle );
		return true;
	}
	else
	{
		return false;
	}
}
?>